use std::collections::{HashMap, VecDeque};

use crate::connectors::{Client, Connector};
use crate::events::Event;
use crate::models::{Order, Position};
use crate::strategy::PositionStrategy;
use crate::ticker::Ticker;

pub struct EventManager {
    events: Vec<Event>,
}

pub struct PositionManager {
    queue: VecDeque<Position>,
    open_positions: Vec<Position>,
    client: Client,
    strategy: Option<Box<dyn PositionStrategy>>,
}

impl PositionManager {
    pub fn new(client: Client) -> Self {
        PositionManager {
            queue: VecDeque::new(),
            open_positions: Vec::new(),
            client,
            strategy: None,
        }
    }

    pub fn with_strategy(mut self, strategy: Box<dyn PositionStrategy>) -> Self {
        self.strategy = Some(strategy);
        self
    }

    pub fn update(&self) -> Option<Vec<Event>> {
        unimplemented!()
    }
}

pub struct OrderManager {
    queue: VecDeque<Order>,
    open_orders: Vec<Order>,
    client: Client,
}

impl OrderManager {
    pub fn new(client: Client) -> Self {
        OrderManager {
            queue: VecDeque::new(),
            open_orders: Vec::new(),
            client,
        }
    }

    pub fn update(&self) -> Option<Vec<Event>> {
        unimplemented!()
    }
}
